package de.paluno.serviceplatform;

import java.util.Vector;

/**
 * 
 * @author Eric Schmieders (eric.schmieders@sse.uni-due.de)
 *
 */
public class PathCache extends Vector<Vector<Activity>>{
	private Vector<Activity> allActivities;

	public void addExecutionPath(Vector<Activity> allActivity) {
		this.allActivities = allActivity;
	}
	
	public Vector<Activity> getExecutionPath() {
		return allActivities;
	}
	
	public Activity getActivity(String name) {
		for (Activity a: allActivities) 
			if (a.getName().equals(name))
				return a;
		
		return null;
	}
	
	public boolean startsWith(Vector<Activity> path, Vector<Activity> pattern) {
		if (pattern.size() > path.size())
			return false;
		
		for (int i=0; i < pattern.size() ;i++)
			if (!pattern.elementAt(i).sameAs(path.elementAt(i)))
				return false;
		
		return true;
	}
	
	public Vector<Vector<Activity>> getRelevantPaths(Vector<Activity> pathSoFar) {
		Vector<Vector<Activity>> result = new Vector<Vector<Activity>>();
		
		for (Vector<Activity> path: this)
			if (startsWith(path,pathSoFar))
				result.add(path);
		
		return result;
	}

	public static String getPrint(Vector<Activity> v) {
		String print = "( ) -> ";
		for (Activity a: v)
			print += "'"+a.getName()+ "' -> ";
				
		return print+"(*)";
	}
	
	public long getExecutionPathAssumedRT() {
		long result = 0;
		
		for (Activity a: getExecutionPath())
			result += a.getAssumption();
		
		return result;
	}
}